This file consists of notes specific to the Berkeley Seismologial Laboratory (BSL) at UC Berkeley,
based on BSL modifications and configuration parameters.

Compiler : Linux x86_64 gcc (GCC) 4.4.7 20120313 (Red Hat 4.4.7-17)


Running Autoconf/Automake (developer steps):
--------------------------------------------
Step 1. Generate template 'configure.scan' file by scanning source code:
    $ autoscan

Step 2. Create file 'configure.ac' from 'configure.scan':
    $ mv configure.scan configure.ac

Step 3. Customize 'configure.ac' for program name, version, various checks, etc.:
    $ emacs configure.ac

Step 4. Create and edit 'Makefile.am', "src/Makefile.am", "<subdir>/Makefile.am".

Step 5. Run all above tools (again) in the right order:
     $ autoreconf --install

Compile (user steps)
-----------------------------
Step 6. Generate makefiles; need to supply paths to 3rd party include and library files (gps and qlib2 libraries):
     ./configure --prefix $HOME/ntrip --enable-debug --enable-rtcm CPPFLAGS="-I$HOME/ntrip/include -I/share/apps/include" LDFLAGS="-L$HOME/ntrip/lib -L/share/apps/lib64"

Step 7. Compile
     make 

Step 8: Install # careful here - there may be a running executable; stop services or move/rename the running executable first
     make install

Parameters to add:
-----------------
- time to wait for data (default 60s)
- reconnect frequency   (default 1s)
- reconnect attempts    (default 10)


BUGS:
-----
BUG#1: No data on serial thread, not timing out after 60s to reconnect(default)

BUG#2: Hanging (no data written for minutes to hours) Bug:

(1) thread_read_data:
sharc.cpp: main
   sharcrt.cpp: sharcStream
      sharcrt.cpp: createReadThread
         sharcrt.cpp: readDataThread
            StremBinex.cpp: ProcessInput
(2) thread_serial:
sharcrt.cpp: sharcStream
   sharcrt.cpp: serialThread

e.g., sharc-22779.log.foo (SODB):
Sun Jan 29 16:36:17 2012 UTC StreamBinex::ProcessInput: record_id = 148, record_len = 245543057, rc = 0
StreamBinex::ProcessInput() seems to get stuck in this loop for a long time:
	for (unsigned int i = 0; i < record_len; i++) {
		cur_packet.push_back(buffer[i]);
	}


How does sharc handle timeouts for socket connections?
------------------------------------------------------
see "socket.cpp"
timeout on write thread set to 5000 millisecs by default
If set to -ve # will poll forever


2010/10/05 sharc bug
--------------------
Description: sharc seems to dump core when there's no data from the source stream for a while.

Core was generated by `/home/gps/UStream/bin/sharc --configfile /home/gps/ntrip/prod/service/CAND/shar'.
Program terminated with signal 7, Bus error.
#0  0x0000000000438cea in isCharAvail (_fd=-1, timeout=20) at utils.cpp:1279
1279            FD_SET(_fd, &rfds);
(gdb) where
#0  0x0000000000438cea in isCharAvail (_fd=-1, timeout=20) at utils.cpp:1279
#1  0x0000000000431518 in Serial::isCharAvailable (this=0x1f8a49a0, timeout=20) at serial.cpp:548
#2  0x00000000004308f7 in Serial::Read (this=0x1f8a49a0, buf=0x44d65cd0, max=1024, timeout=20) at serial.cpp:711
#3  0x0000000000446d71 in serialThread (argin=0x7fff4cf586d4) at sharcrt.cpp:408
#4  0x0000003b20a0673d in start_thread () from /lib64/libpthread.so.0
#5  0x0000003b1fed3d1d in clone () from /lib64/libc.so.6

2010/10/32 sharc bug
--------------------
Description: Problem communicating with NetRS: for PKDB apparently NetRS restarted itself for TEST is
             apparently did not restart itself.

Core was generated by `/home/gps/UStream/bin/sharc --configfile /home/gps/ntrip/prod/service/PKDB/shar'.
Program terminated with signal 6, Aborted.
#0  0x0000003024a30265 in raise () from /lib64/libc.so.6
(gdb) where
#0  0x0000003024a30265 in raise () from /lib64/libc.so.6
#1  0x0000003024a31d10 in abort () from /lib64/libc.so.6
#2  0x000000302b2becb4 in __gnu_cxx::__verbose_terminate_handler() () from /usr/lib64/libstdc++.so.6
#3  0x000000302b2bcdb6 in ?? () from /usr/lib64/libstdc++.so.6
#4  0x000000302b2bcde3 in std::terminate() () from /usr/lib64/libstdc++.so.6
#5  0x000000302b2bceca in __cxa_throw () from /usr/lib64/libstdc++.so.6
#6  0x000000000045391b in Socket::_read (this=0x17df49a0, d=3, buf=0x434b7cd0, nbytes=1024, flags=64) at socket.cpp:284
#7  0x000000000043093d in Serial::Read (this=0x17df49a0, buf=0x434b7cd0, max=1024, timeout=20) at serial.cpp:722
#8  0x0000000000446e78 in serialThread (argin=0x7fff8473b994) at sharcrt.cpp:418
#9  0x000000302560673d in start_thread () from /lib64/libpthread.so.0
#10 0x0000003024ad3f6d in clone () from /lib64/libc.so.6


Core was generated by `/home/gps/UStream/bin/sharc --configfile /home/gps/ntrip/prod/service/TEST/shar'.
Program terminated with signal 6, Aborted.
#0  0x0000003024a30265 in raise () from /lib64/libc.so.6
(gdb) where
#0  0x0000003024a30265 in raise () from /lib64/libc.so.6
#1  0x0000003024a31d10 in abort () from /lib64/libc.so.6
#2  0x000000302b2becb4 in __gnu_cxx::__verbose_terminate_handler() () from /usr/lib64/libstdc++.so.6
#3  0x000000302b2bcdb6 in ?? () from /usr/lib64/libstdc++.so.6
#4  0x000000302b2bcde3 in std::terminate() () from /usr/lib64/libstdc++.so.6
#5  0x000000302b2bceca in __cxa_throw () from /usr/lib64/libstdc++.so.6
#6  0x000000000045391b in Socket::_read (this=0xba079a0, d=3, buf=0x45cd9cd0, nbytes=1024, flags=64)
    at socket.cpp:284
#7  0x000000000043093d in Serial::Read (this=0xba079a0, buf=0x45cd9cd0, max=1024, timeout=20) at serial.cpp:722
#8  0x0000000000446e78 in serialThread (argin=0x7ffff9900f44) at sharcrt.cpp:418
#9  0x000000302560673d in start_thread () from /lib64/libpthread.so.0
#10 0x0000003024ad3f6d in clone () from /lib64/libc.so.6




---
utils.cpp:  isCharAvail()
	    Check if file descr _fd is valid and -1 > _fd < FD_SETSIZE before calling FD_SET.
	    select() is called in non-blocking mode.
	    Check return value of select: -1 => errno set, 0 = > timeout before anything interesting happens, 1 => OK.
	    If select fails or times out a timer is set for 20 secs and select is called again with blocking for 20 secs.
	    setitimer() is used to return the time left after the blocking select().
            Check return values of setitimer().
            Why return the time remaining?
            Should we use pslelect()?
	    Replace select() with newer/simpler/more-flexible poll() ?

serial.cpp: _read()
	    Since we have a socket connection why not use recv() instead of read() ?

2010/10/11 Sharc bug
--------------------
Description: Streaming BINEX only without writing RTCM sharc tries to open an RTCM antenna file.
Debugging gives the following message:
StreamType::MakeRTCMInfoRecords: Unable to open : No such file or directory

sharcrt.h:
typedef struct read_thread_info {
...
	bool translateRTCM;
}

typedef struct writerinfo {
...
	bool outputRTCM;
...
}

Receiver.h:
struct OpsStruct {
...
	bool translateRTCM
}

StreamType.h:
class StreamType {
      ...
public:
	...	
	bool allowRTCM() { return(translateRTCM); };
protected:
	...
	bool translateRTCM;      
}

StreamBinex.cpp:
int StreamBinex::ProcessInput(int fd, time_t timeout)
{
...
	translateRTCM = TRUE;
}

sharcrt.cpp:

int sharcStream(SOps *pOps) {
...
	read_info.translateRTCM = pOps->translateRTCM;
	read_info.antennaFile = pOps->RTCMantennafile;
...
}


checkSample: Sample rate is 1000
writeDataThread: Getting record from cache entry 0
writeDataThread: record of size 156
getSaveFile: Entering dir_template=/home/gps/ntrip/prod/data/BRIB  file_template=BRIB-%Y-%j-%H.BINEX
getSaveFile: Entering dir=  filename= rec_time=315964800
getSaveFile: dir is now /home/gps/ntrip/prod/data/BRIB
getSaveFile: Opening /home/gps/ntrip/prod/data/BRIB/BRIB-1980-006-00.BINEX
getSaveFile: Opening binex file handle
getSaveFile: Exiting
writeDataThread: Filename not changed
writeDataThread: Writing to /home/gps/ntrip/prod/data/BRIB/BRIB-1980-006-00.BINEX
writeDataThread: Return from write, rc = 0, bytes_out = 162
writeDataThread: wrote record of size 162 with result 0


BINEX -> RTCM conversion
------------------------
There appear to be bug(s) in this functinality.
Comparing RINEX of the BINEX source file to the RINEX of the RTCM3.x from sharc
using 'teqc' and 'bnc' respectively for the RINEXing, there are significant differences.
The BINEX results compare closely with those of RT17 and from streaming RTCM3.0
directly from the receiver. So sharc translation of BINEX to RTCM3.x must be at
fault.

Here's the sharc function calling sequence:
readDataThread()
   InitRTCM() (StreamBinex is the class, StreamType is the super class)
   ProcessInput()
   GetRecord()
   GetRecordInfo()
   DecomposePacket()
	InitRTCMStruct()
	read_0x7f03()
   GetRTCMRecords()
	InitRTCMStruct()
	DecomposePacket()
	MakeRTCMInfoRecords()
	MakeRTCMRecord()
	MakeRTCM3Record()
   ResetPacket()
   GetRecordTime()

createWriteThread
  writeDataThread()
     write_binex()

  writeNetworkThread()
     getOutputData()
	

sharc 'CLOSE_WAIT' issue
------------------------
sharc not exiting when socket connection is in CLOSE_WAIT and no data is being received for several minutes.

WaitFor - timeout is 5000
timer set to 1000

Topcon.cpp, line 158: pSerial->Read((void *)a,300,1000);
   Why is the return value of Read() being ignored?
   What is done with the chars read into buffer 'a[300]'?

serial.cpp: Serial::Read()
    _fd is declared in serial.h

sharcrt.cpp:serialThread()

2020/08/21 'sharc' bug
----------------------
While testing new Topcon f/w v4.8p1 'sahrc' does an exit(-1) on the following warning:
Fri Aug 21 19:51:52 2020 UTC read_0x7f05: Warning: Unknown Satellite System (14) with SVid 8, skipping decode
FIX: Keep warning but don't quit.