/* 
#    $Id: MicroZ.h,v 1.2 2012/02/10 00:48:57 gps Exp $
#
#    Ashtech.h -- Include file for the Ashtech Receiver
#
#    Copyright (C) 2000 US Geological Survey
#    Written by Keith F. Stark
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _MICROZ_H
#define _MICROZ_H

#include <fstream>
#include <string>

#include <Ashtech.h>
#include <AshtechDefs.h>
#include <Receiver.h>
#include <gpstime.h>
#include <gpscommon.h>

#define FILELENGTH 12
#define ASHBYTEORDER __BIG_ENDIAN

class MicroZ : public Ashtech {
public:
	MicroZ();

// Download fat
	static int DownloadReceiverFAT(Serial *pSerial);
// Set Sessions
	static int SetReceiverSession(Serial *pSerial);
	void AddImage(Ashtech *newAshtech);


	static int VerifyReceiverSession(Serial *pSerial);

	VIRTUAL int DownloadFileByTime(Serial *pSerial, gpstime *start, gpstime *stop);
	// Download File routines
	VIRTUAL int DownloadFileAtIndex(Serial *pSerial, int index);

	VIRTUAL int DeleteFileAtIndex(Serial *pSerial, int index);

private:
	// File Data
	static string UZ_FileNames[MAX_RCVR_FILES];

};

#endif
