/* 
#    $Id: StreamBinex.h,v 1.1 2011/04/04 17:29:34 gps Exp $
#
#    StreamBinex.h -- Include file for the Ashtech Receiver
#
#    Copyright (C) 2000 US Geological Survey
#    Written by Keith F. Stark
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _STREAMBINEX_H
#define _STREAMBINEX_H

#if USE_STREAM

#include <fstream>
#include <string>

#include "Ashtech.h"
#include "AshtechDefs.h"
#include "Receiver.h"
#include "gpstime.h"
#include "gpscommon.h"
#include "StreamType.h"
#include "binex.h"

#define BINEX_RECORD_ID 1
#define BINEX_REVERSIBLE 2
#define BINEX_LITTLE_ENDIAN 3


class StreamBinex : public StreamType {

public:
	StreamBinex() { rbh = NULL; };
	~StreamBinex() { };

	int ProcessInput(int fd, time_t timeout);
	int DecomposePacket ();
	int GetRecordTime(long *gpsMinutes, unsigned short *gpsm_Seconds);

	long long int GetRecordInfo(int INFOTYPE);

private:

	binexHandle *rbh;
	unsigned int record_id;
	int reversible;
	int little_endian;


};

#endif

#endif
