/* 
#    $Id: TrimbleDefs.h,v 1.3 2012/02/10 00:48:57 gps Exp $
#
#    TrimbleDefs.h -- Data Structures 
#
#    Copyright (C) 2000 US Geological Survey
#    Written by Keith F. Stark
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _TRIMBLE_DEFS_H
#define _TRIMBLE_DEFS_H

/****************************************************************************/
/* these defs are for the new development                                   */
/****************************************************************************/

#define RFILE "rfile"
#define RCONN "rconn"
#define RDISCONN "rdisconn"
#define RSESSION "rsession"
#define RSTATUS "rstatus"
#define RSURVEY "rsurvey"
#define RCONTROL "rcontrol"
#define RDATNAME "rdatname"
#define RRESET "rreset"
#define RUNPKR00 "runpkr00"
#define RSTATION "rstation"

#define GENERAL_TIMEOUT 10000L
#define DELETION_TIMEOUT 120000L
#define TRIMBLE_XMODEM_CLEANUP_TIMEOUT 10000L

#define NUM_EXTRA_TRIMBLE_XMODEM_EOT 4
#define MAX_PROG_SESSIONS 24
#define MAX_TRIMBLE_FILES 100
#define INTERMEDIATEHEADERLEN 20

/****************************************************************************/
#define SITENAME_LEN 4    /* The number of charactes used by the site name. */
#define OPERATOR_LEN 12   /* Number of characters for operator field.       */
#define PROJECT_LEN  34   /* Number of characters for project field.        */
/****************************************************************************/


#endif /*define TRIMBLE_DEFS_H */
