/* 
#    $Id: gpstime.h,v 1.1 2011/04/04 17:29:34 gps Exp $
#
#    gpstime -- definitions for gpstime.cpp
#
#    Copyright (C) 2000 US Geological Survey
#    Written by Keith F. Stark
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _GPSTIME_H   
#define _GPSTIME_H   
#include <time.h>  

#define REPLACE(a, b, c) \
    find = (b); \
    replace = (c); \
    start = (a).find(find); \
    while (start != string::npos) { \
        (a).replace(start, find.length(), replace); \
        start = (a).find(find, start + replace.length()); \
    } \

   
class gpstime {
   
public:
	gpstime(); 

	int	set_time(); 
	int	set_time(time_t intime_t); 
	int	set_time(double inMJD);
	int	set_time(int inyear,int inmonth,double inday); 
	int	set_time(int gpsweek, double gpssec);
	int	set_time(int inyear, double inday,char c);
	int	set_time(int hour, int minute, double second,char c);
	int	set_time(int year, char *month, int day, int hour, int minute, double second);
	int	set_time(int year, int month, int day, int hour, int minute, double second);
	int	set_time_x(double in);

	double	getMJD();
	time_t	gettime_t()
		{ return(the_time); };
	int	getjmt(int *outyear,double *outday);
	int	getgps(int *outweek,double *outsec);
	char*	chartime(const char *format,char *buffer,int smax);

	int	operator ==(gpstime othertime)
		{ return(this->getMJD() == othertime.getMJD()); };

	int	operator =(gpstime othertime)
		{ return(this->set_time(othertime.getMJD())); }

	int	operator <(gpstime othertime)
		{ return(this->getMJD() < othertime.getMJD()); };

	int	operator <=(gpstime othertime)
		{ return(this->getMJD() <= othertime.getMJD()); };

	int	operator >(gpstime othertime)
		{ return(this->getMJD() > othertime.getMJD()); };

	int	operator >=(gpstime othertime)
		{ return(this->getMJD() >= othertime.getMJD()); };

	int		set()
		{ return(isset); };

	void	add(double input)
		{ partial += input; chkpartial(); };

	void	chkpartial();
   
protected:
	time_t	find_thetime(int inyear,int inday, int outmonth); 

private:   
	time_t	the_time;
	double	partial; 
	int	isset;
}; 
   
#endif   /* ifdef TIMEHPP */  
   
