/* 
#    $Id: ttylock.h,v 1.1 2011/04/04 17:29:34 gps Exp $
#
#    Copyright (C) 2000 US Geological Survey
#    Written by Keith F. Stark
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _TTYLOCK_H_
#define _TTYLOCK_H_

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
//#include <sys/dirent.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef __sparc
#else
#include <sys/cdefs.h>
#endif

#ifdef	__cplusplus
extern "C" {
#endif

#ifndef _PATH_LOCK
#  define LOCK_PATH	"/var/lock/"
#else
#  define LOCK_PATH	_PATH_LOCK
#endif
#ifndef _PATH_DEV
#  define DEV_PATH	(char *) "/dev/"
#else
#  define DEV_PATH	(char *)_PATH_DEV
#endif

/* Can be undefined if /dev/cua* not used */
//#define USE_ALT 1

#ifdef USE_ALT
#define TTYS "ttyS"
#define ALT "cua"
char alt_name[MAXNAMLEN];
#endif

	/* When MY_DEBUG is defined, debugging messages can be issued
	 * if the calling process defines 'int debug'.  This makes this
	 * library less than portable. */
#define MY_DEBUG

#ifdef __cplusplus
extern int ttylock ( char * );
extern int ttyunlock ( char * );
extern int ttyrelock ( char *, int );
#else
extern int ttylock __P(( char * ));
extern int ttyunlock __P(( char * ));
extern int ttyrelock __P(( char *, int ));
#endif

/* extern int ttywait __P( char * ); Later, maybe */

#ifdef	__cplusplus
};
#endif

#endif /* _TTYLOCK_H_ */
